## apngasm 2.7

=== Makefile ===
all:
	gcc -std=c99 -Wall -pedantic -O2 -o apngasm apngasm.c -lz -lpng

=== debian/changelog ===
apngasm (2.7-2) unstable; urgency=medium

  * QA upload.
  * Orphaning package, maintainer not active.
  * Fix typo in description, thanks Pascal De Vuyst (Closes: #732769)
  * Bump Policy Standards-Version to 3.9.8 (no changes needed)
  * Update Vcs-* URLs
  * Use build date for manpage (for reproducible builds).  Thanks Reiner
    Herrmann.  (Closes: #782200)

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Thu, 26 May 2016 11:36:19 +0100

apngasm (2.7-1) unstable; urgency=low

  * Initial release (Closes: #663415).
  * Use hardened build flags.
    http://wiki.debian.org/ReleaseGoals/SecurityHardeningBuildFlags

 -- Jari Aalto <jari.aalto@cante.net>  Sat, 01 Jun 2013 07:37:05 +0300

=== debian/control ===
Source: apngasm
Section: graphics
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>= 9), libz-dev, libpng-dev
Standards-Version: 3.9.8
Homepage: https://sourceforge.net/projects/apngasm
Vcs-Git: https://anonscm.debian.org/git/collab-maint/apngasm.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/apngasm.git/

Package: apngasm
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: apng2gif
Description: assemble APNG animation from PNG/TGA image sequence
 Tools to create APNG file from individual PNG files with user
 given delay.
 .
 The Animated Portable Network Graphics (APNG) file format is an
 extension to the Portable Network Graphics (PNG) specification. It
 allows for animated PNG files that work similarly to animated GIF
 files, while retaining backward compatibility with non-animated PNG
 files and adding support for 8-bit transparency and 24-bit images.

=== debian/rules ===
#!/usr/bin/make -f

PACKAGE = apngasm
BIN	= $(PACKAGE)
CC     ?= gcc
LIBS	= -lz -lpng

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
CFLAGS	+= -Wall -std=c99
LDFLAGS += -Wl,--as-needed

include debian/pod2man.mk

man:
	$(MAKE) -C debian -f pod2man.mk PACKAGE=$(PACKAGE) makeman

override_dh_auto_build: man
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) $(PACKAGE).c -o $(BIN) $(LIBS)

override_dh_installchangelogs:
	dh_installchangelogs readme.txt

%:
	dh $@

# End of file

=== debian/watch ===
version=3
opts="filenamemangle=s/-src//" \
  http://sf.net/apngasm/apngasm-(.+)-src\.zip  debian debian/repack.sh

## apngasm 2.91

=== Makefile ===
PACKAGE    = apngasm
CC         = gcc
SRC_DIRS   = . 7z zopfli
CFLAGS     = -Wall -pedantic -DFEATURE_7ZIP -DFEATURE_ZOPFLI
CFLAGS_OPT = -O2
CFLAGS_7Z  = -Wno-sign-compare -Wno-reorder -Wno-maybe-uninitialized -Wno-parentheses
LIBS       = -lstdc++ -lm -lpng -lz

INCUDE_DIRS := $(addprefix -I./, $(SRC_DIRS))
OBJ_DIRS := $(addprefix obj/, $(SRC_DIRS))
OBJECTS := $(addprefix obj/, $(wildcard $(addsuffix /*.c*, $(SRC_DIRS))))
OBJECTS := $(OBJECTS:.c=.o)
OBJECTS := $(OBJECTS:.cc=.o)
OBJECTS := $(OBJECTS:.cpp=.o)

all : $(PACKAGE)

$(PACKAGE) : objdirs $(OBJECTS)
	$(CC) -o $@ $(OBJECTS) -s $(LIBS)

objdirs :
	mkdir -p $(OBJ_DIRS)

obj/%.o : %.cpp
	$(CC) -o $@ -c $< $(INCUDE_DIRS) $(CFLAGS) $(CFLAGS_OPT)

obj/%.o : %.c
	$(CC) -o $@ -c $< $(INCUDE_DIRS) $(CFLAGS) $(CFLAGS_OPT)

obj/%.o : %.cc
	$(CC) -o $@ -c $< $(INCUDE_DIRS) $(CFLAGS) $(CFLAGS_OPT) $(CFLAGS_7Z)

.PHONY : clean

clean : 
	rm -rf $(PACKAGE) obj

=== debian/changelog ===
apngasm (2.91-3) unstable; urgency=medium

  * QA upload.
  * Update compat level to 13.
  * Mark autopkgtest as superficial. (Closes: #970946)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 16 Oct 2020 21:29:46 +0100

apngasm (2.91-2) unstable; urgency=medium

  * QA upload.

  [ Debian Janitor ]
  * Use correct machine-readable copyright file URI.
  * Use secure URI in debian/watch.
  * Update standards version to 4.4.1, no changes needed.
  * Set upstream metadata fields: Archive, Bug-Database.

  [ Sudip Mukherjee ]
  * Update Standards-Version to 4.5.0
  * Add Rules-Requires-Root: no.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 16 Apr 2020 18:29:12 +0100

apngasm (2.91-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.
  * Using new DH level format. Consequently:
      - debian/compat: removed.
      - debian/control: Changed from 'debhelper' to 'debhelper-compat' in
        Build-Depends field and bumped level to 12.
  * debian/control:
      - Standards-Version: bumped to 4.4.0 (no changes needed)
      - Switch VCS URLs to salsa.debian.org
  * debian/copyright:
      - Added safe uri (https) to Format.
      - Full updated.
  * debian/patches/010_fix-gcc-flags.patch: created to improve
        GCC flags to hardenig.
  * debian/rules: updated to new upstream source code.
  * debian/tests/control: added to provide a trivial test.
  * debian/upstream/metadata: created.

 -- Giovani Augusto Ferreira <giovani@debian.org>  Mon, 16 Sep 2019 21:36:00 -0300

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,12 @@
 Section: graphics
 Priority: optional
 Maintainer: Debian QA Group <packages@qa.debian.org>
-Build-Depends: debhelper (>= 9), libz-dev, libpng-dev
-Standards-Version: 3.9.8
+Build-Depends: debhelper-compat (= 13), libz-dev, libpng-dev
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://sourceforge.net/projects/apngasm
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/apngasm.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/apngasm.git/
+Vcs-Git: https://salsa.debian.org/debian/apngasm.git
+Vcs-Browser: https://salsa.debian.org/debian/apngasm
 
 Package: apngasm
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

include debian/pod2man.mk

PACKAGE = apngasm

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

man:
	$(MAKE) -C debian -f pod2man.mk PACKAGE=$(PACKAGE) makeman

override_dh_installman: man
	dh_installman

override_dh_installchangelogs:
	dh_installchangelogs readme.txt

=== debian/tests/control ===
Test-Command: apngasm | grep APNG
Restrictions: superficial

=== debian/watch ===
version=3
opts="filenamemangle=s/-src//" \
  https://sf.net/apngasm/apngasm-(.+)-src\.zip  debian debian/repack.sh

## apngasm python-1.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17)
cmake_policy(SET CMP0074 NEW)

if (WIN32)
    set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
elseif (LINUX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
elseif (APPLE)
    set(CMAKE_OSX_DEPLOYMENT_TARGET "10.15")
endif()

if (WIN32)
    set(GET_TARGET_CMD "cmd" "/c" "${CMAKE_SOURCE_DIR}/get-target-win.bat")
    set(PREPARE_CMD "cmd" "/c" "${CMAKE_SOURCE_DIR}/prepare-win.bat")
elseif (APPLE)
    set(GET_TARGET_CMD "${CMAKE_SOURCE_DIR}/get-target-mac.sh")
    set(PREPARE_CMD "${CMAKE_SOURCE_DIR}/prepare-mac.sh")
else()
    set(GET_TARGET_CMD "${CMAKE_SOURCE_DIR}/get-target-linux.sh")
    set(PREPARE_CMD "${CMAKE_SOURCE_DIR}/prepare-linux.sh")
endif()

execute_process(
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    COMMAND ${PREPARE_CMD}
)

set(Boost_USE_STATIC_LIBS ON)
if (WIN32)
    set(Boost_USE_MULTITHREADED ON)
    set(Boost_USE_STATIC_RUNTIME ON)
    set(STATIC_LIBRARY_SUFFIX ".lib")
else()
    set(STATIC_LIBRARY_SUFFIX ".a")
endif()

if (DEFINED ENV{VCPKG_INSTALLATION_ROOT})
    set(VCPKG_INSTALLATION_ROOT $ENV{VCPKG_INSTALLATION_ROOT})
endif()

if (DEFINED VCPKG_INSTALLATION_ROOT)
    if (DEFINED ENV{APNGASM_COMPILE_TARGET})
        set(APNGASM_COMPILE_TARGET $ENV{APNGASM_COMPILE_TARGET})
    elseif (NOT DEFINED APNGASM_COMPILE_TARGET)
        execute_process(
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            COMMAND ${GET_TARGET_CMD}
            OUTPUT_VARIABLE APNGASM_COMPILE_TARGET
        )
        if (DEFINED ENV{APNGASM_COMPILE_TARGET})
            set(APNGASM_COMPILE_TARGET $ENV{APNGASM_COMPILE_TARGET})
        endif()
    endif()

    if (DEFINED ENV{PLATFORM})
        set(PLATFORM $ENV{PLATFORM})
    elseif (NOT DEFINED PLATFORM)
        if (WIN32)
            set(PLATFORM windows-static)
        elseif (APPLE)
            set(PLATFORM osx)
        else()
            set(PLATFORM linux)
        endif()
    endif()

    if (WIN32)
        set(LIBZ_NAME zlib)
        set(LIBPNG_NAME libpng16)
    else()
        set(LIBZ_NAME libz)
        set(LIBPNG_NAME libpng16)
    endif()

    set(ZLIB_ROOT ${VCPKG_INSTALLATION_ROOT}/installed)
    set(PNG_ROOT ${VCPKG_INSTALLATION_ROOT}/installed)
    set(Boost_ROOT ${VCPKG_INSTALLATION_ROOT}/installed)
    
    set(VCPKG_TARGET_TRIPLET ${APNGASM_COMPILE_TARGET}-${PLATFORM})

    include_directories(${VCPKG_INSTALLATION_ROOT}/installed/${VCPKG_TARGET_TRIPLET}/include)
    set(LIBZ_PATH ${VCPKG_INSTALLATION_ROOT}/installed/${VCPKG_TARGET_TRIPLET}/lib/${LIBZ_NAME}${STATIC_LIBRARY_SUFFIX})
    set(LIBPNG_PATH ${VCPKG_INSTALLATION_ROOT}/installed/${VCPKG_TARGET_TRIPLET}/lib/${LIBPNG_NAME}${STATIC_LIBRARY_SUFFIX})
    set(CMAKE_TOOLCHAIN_FILE "${VCPKG_INSTALLATION_ROOT}/scripts/buildsystems/vcpkg.cmake"
      CACHE STRING "Vcpkg toolchain file")
else()
    if (WIN32)
        set(LIBZ_NAME zlibstatic)
        set(LIBPNG_NAME libpng16_static)
    else()
        set(LIBZ_NAME libz)
        set(LIBPNG_NAME libpng16)
    endif()

    set(ZLIB_ROOT ${CMAKE_SOURCE_DIR}/fakeroot)
    set(PNG_ROOT ${CMAKE_SOURCE_DIR}/fakeroot)
    set(Boost_ROOT ${CMAKE_SOURCE_DIR}/fakeroot)

    set(LIBZ_PATH ${CMAKE_SOURCE_DIR}/fakeroot/lib/${LIBZ_NAME}${STATIC_LIBRARY_SUFFIX})
    if(NOT EXISTS ${LIBZ_PATH})
        set(LIBZ_PATH ${CMAKE_SOURCE_DIR}/fakeroot/lib64/${LIBZ_NAME}${STATIC_LIBRARY_SUFFIX})
    endif()

    set(LIBPNG_PATH ${CMAKE_SOURCE_DIR}/fakeroot/lib/${LIBPNG_NAME}${STATIC_LIBRARY_SUFFIX})
    if(NOT EXISTS ${LIBPNG_PATH})
        set(LIBPNG_PATH ${CMAKE_SOURCE_DIR}/fakeroot/lib64/${LIBPNG_NAME}${STATIC_LIBRARY_SUFFIX})
    endif()
endif()

project(apngasm-python VERSION 1.0.1)
set(PY_VERSION_SUFFIX "")
set(PY_FULL_VERSION ${PROJECT_VERSION}${PY_VERSION_SUFFIX})

# Make sure that the Python and CMake versions match
if (DEFINED PY_BUILD_CMAKE_PACKAGE_VERSION)
    if (NOT "${PY_BUILD_CMAKE_PACKAGE_VERSION}" MATCHES "^${PY_FULL_VERSION}$")
        message(FATAL_ERROR "Version number does not match "
                             "(${PY_BUILD_CMAKE_PACKAGE_VERSION} - ${PY_FULL_VERSION}).")
    endif()
endif()

# Find the nanobind package
include(cmake/QueryPythonForNanobind.cmake)
find_nanobind_python_first()

# Compile the Python module
nanobind_add_module(_apngasm_python "src/apngasm_python.cpp" NB_STATIC STABLE_ABI)
if (WIN32)
    nanobind_compile_options(_apngasm_python "/MT /MP /bigobj")
endif()
target_compile_definitions(_apngasm_python PRIVATE _apngasm_python_EXPORTS)
target_compile_definitions(_apngasm_python PRIVATE apngasm_EXPORTS)

# Static linking
add_library(zlibstatic STATIC IMPORTED)
add_library(png_static STATIC IMPORTED)

add_subdirectory(apngasm)
set_target_properties(apngasm-static PROPERTIES BUILD_SHARED_LIBS OFF)

include_directories(${CMAKE_SOURCE_DIR}/fakeroot/include)
include_directories(${CMAKE_BINARY_DIR}/apngasm/lib/src)
include_directories(${CMAKE_SOURCE_DIR}/apngasm/lib/src)
include_directories(${CMAKE_SOURCE_DIR}/apngasm/lib/src/listener)

set_target_properties(zlibstatic PROPERTIES IMPORTED_LOCATION ${LIBZ_PATH})
set_target_properties(png_static PROPERTIES IMPORTED_LOCATION ${LIBPNG_PATH})

target_link_libraries(_apngasm_python PRIVATE apngasm-static png_static zlibstatic)

target_compile_definitions(_apngasm_python PRIVATE
    MODULE_NAME=$<TARGET_FILE_BASE_NAME:_apngasm_python>
    VERSION_INFO="${PY_FULL_VERSION}"
)

# Hide all symbols by default (including external libraries on Linux)
set_target_properties(_apngasm_python PROPERTIES
    CXX_VISIBILITY_PRESET "hidden"
    VISIBILITY_INLINES_HIDDEN true
    POSITION_INDEPENDENT_CODE true)
if (WIN32)
    set_target_properties(_apngasm_python PROPERTIES LINK_FALGS_RELEASE "/WHOLEARCHIVE:MNN")
elseif (LINUX)
    target_link_options(_apngasm_python PRIVATE "LINKER:--exclude-libs,ALL")
endif()

# Install the module
install(TARGETS _apngasm_python
    EXCLUDE_FROM_ALL
    DESTINATION ${PY_BUILD_CMAKE_MODULE_NAME}
    COMPONENT python_module)

# Generate stubs for the Python module
option(WITH_PY_STUBS
    "Generate Python stub files (.pyi) for the Python module." On)
if (WITH_PY_STUBS AND NOT CMAKE_CROSSCOMPILING)
    include(cmake/NanobindStubgen.cmake)
    nanobind_stubgen(_apngasm_python)
    nanobind_stubgen_install(_apngasm_python ${PY_BUILD_CMAKE_MODULE_NAME})
endif()

## apngasm python-1.0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -109,7 +109,7 @@
     endif()
 endif()
 
-project(apngasm-python VERSION 1.0.1)
+project(apngasm-python VERSION 1.0.3)
 set(PY_VERSION_SUFFIX "")
 set(PY_FULL_VERSION ${PROJECT_VERSION}${PY_VERSION_SUFFIX})

=== apngasm/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

project(APNGASM)

# If BUILD_SHARED_LIBS was set to OFF, prepare for static linking
if (DEFINED BUILD_SHARED_LIBS AND NOT BUILD_SHARED_LIBS)
  set(Boost_USE_STATIC_LIBS ON)
  if (MSVC)
    set(Boost_USE_MULTITHREADED ON)
    set(Boost_USE_STATIC_RUNTIME ON)
  endif()

  set(ZLIB_USE_STATIC_LIBS ON)
  
  if (MSVC)
    set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
  elseif (LINUX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
  endif()
endif()

add_subdirectory(${PROJECT_SOURCE_DIR}/lib)
add_subdirectory(${PROJECT_SOURCE_DIR}/cli)
add_subdirectory(${PROJECT_SOURCE_DIR}/test)

# Create package command
if (UNIX OR APPLE OR MINGW)
  add_custom_target(
    package
    COMMAND ${CMAKE_MAKE_PROGRAM}
    COMMAND ${CMAKE_MAKE_PROGRAM} package-lib
    COMMAND ${CMAKE_MAKE_PROGRAM} package-cli
    WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
  )
endif ()

=== apngasm/cli/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

project(APNGASM_CLI)

### Set version
set(APNGASM_CLI_VERSION_MAJOR 3)
set(APNGASM_CLI_VERSION_MINOR 1)
set(APNGASM_CLI_VERSION_PATCH 10)

# Set the version code
set(APNGASM_CLI_VERSION "${APNGASM_CLI_VERSION_MAJOR}.${APNGASM_CLI_VERSION_MINOR}.${APNGASM_CLI_VERSION_PATCH}")
# Generate a header file with the version code
configure_file(${PROJECT_SOURCE_DIR}/src/apngasm-cli-version.h.in ${PROJECT_BINARY_DIR}/src/apngasm-cli-version.h @ONLY)

# Add include paths
include_directories(
  ${PROJECT_BINARY_DIR}/src
  ${PROJECT_SOURCE_DIR}/../lib/src
  ${PROJECT_BINARY_DIR}/../lib/src # Version header is generated here
)

# Add library build path to link directory paths
link_directories(BEFORE ${PROJECT_BINARY_DIR}/../lib)

# Hack for MSYS2 to detect packages properly
# Note: this hack necessitates a 64 bit build
if (MSYS)
  include_directories("/mingw64/include")
  link_directories("/mingw64/lib")
  set(Boost_ROOT "/mingw64")
endif ()

# Search and prepare Boost
find_package(Boost REQUIRED COMPONENTS program_options regex system)
include_directories(${Boost_INCLUDE_DIRS})

find_package(ZLIB REQUIRED)
include_directories(${ZLIB_INCLUDE_DIRS})

find_package(PNG REQUIRED)
include_directories(${PNG_INCLUDE_DIRS})

# Generate executable
add_executable(apngasm-cli
  ${PROJECT_SOURCE_DIR}/src/apngasm-cli.cpp
  ${PROJECT_SOURCE_DIR}/src/options.cpp
  ${PROJECT_SOURCE_DIR}/src/cli.cpp
)
set_target_properties(apngasm-cli
  PROPERTIES 
  OUTPUT_NAME apngasm
  CXX_STANDARD 20
)

# Link to built apngasm library
target_link_libraries(apngasm-cli
  apngasm
  ${Boost_LIBRARIES} ${PNG_LIBRARIES} ${ZLIB_LIBRARIES}
)

# Installation
install(TARGETS apngasm-cli DESTINATION "bin")

# Create package command
set(PACKAGE_DIR ${PROJECT_BINARY_DIR}/package)
set(APNGASM_BINARIES ${PROJECT_BINARY_DIR}/apngasm${CMAKE_EXECUTABLE_SUFFIX})

if (WIN32 AND NOT MINGW)
  set(INSTALL_HEADERS
    ${PROJECT_SOURCE_DIR}/../lib/src/apngasm.h
    ${PROJECT_SOURCE_DIR}/../lib/src/apngframe.h
    ${PROJECT_SOURCE_DIR}/../lib/src/apngasm-conf.h
    ${PROJECT_BINARY_DIR}/../lib/src/apngasm-version.h)
  #get_property(INSTALL_LIBS TARGET apngasm PROPERTY LOCATION)
  #string(REPLACE "$(Configuration)" "\\\${CMAKE_INSTALL_CONFIG_NAME}" INSTALL_APPS "${INSTALL_APPS}")
  #string(REPLACE "$(Configuration)" "\\\${CMAKE_INSTALL_CONFIG_NAME}" INSTALL_LIBS "${INSTALL_LIBS}")
endif ()

include(${PROJECT_BINARY_DIR}/../lib/manifest.txt)
configure_file(${PROJECT_SOURCE_DIR}/package/CMakeLists.txt.in ${PACKAGE_DIR}/CMakeLists.txt @ONLY)

if (UNIX OR APPLE OR MINGW)
  add_custom_target(
    package-cli
    COMMAND ${CMAKE_COMMAND} .
    COMMAND ${CMAKE_MAKE_PROGRAM} package
    WORKING_DIRECTORY ${PACKAGE_DIR}
  )
  install(FILES ${PROJECT_SOURCE_DIR}/../docs/man/apngasm.1 DESTINATION ${CMAKE_INSTALL_PREFIX}/man/man1)
endif ()

=== apngasm/lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

project(APNGASM_LIB)

### Set version
set(APNGASM_LIB_VERSION_MAJOR 3)
set(APNGASM_LIB_VERSION_MINOR 1)
set(APNGASM_LIB_VERSION_PATCH 10)

# Set the version code
set(APNGASM_LIB_VERSION "${APNGASM_LIB_VERSION_MAJOR}.${APNGASM_LIB_VERSION_MINOR}.${APNGASM_LIB_VERSION_PATCH}")
# Generate a header file with the version code
configure_file(${PROJECT_SOURCE_DIR}/src/apngasm-version.h.in ${PROJECT_BINARY_DIR}/src/apngasm-version.h @ONLY)
# Generate a package manifest file with the version
configure_file(${PROJECT_SOURCE_DIR}/manifest.txt.in ${PROJECT_BINARY_DIR}/manifest.txt @ONLY)

include_directories(${PROJECT_BINARY_DIR}/src)

# Sources and Headers
set(APNGASM_HEADERS
  ${PROJECT_SOURCE_DIR}/src/apngasm.h
  ${PROJECT_SOURCE_DIR}/src/apngframe.h
  ${PROJECT_SOURCE_DIR}/src/apngasm-conf.h
  ${PROJECT_BINARY_DIR}/src/apngasm-version.h
)
set(APNGASM_SOURCES
  ${PROJECT_SOURCE_DIR}/src/apngasm.cpp
  ${PROJECT_SOURCE_DIR}/src/apngframe.cpp
  ${PROJECT_SOURCE_DIR}/src/spec/specreader.cpp
  ${PROJECT_SOURCE_DIR}/src/spec/specwriter.cpp
  ${PROJECT_SOURCE_DIR}/src/spec/priv/specreaderimpl.cpp
  ${PROJECT_SOURCE_DIR}/src/spec/priv/specwriterimpl.cpp
  ${PROJECT_SOURCE_DIR}/src/listener/apngasmlistener.cpp
)

# Hack for MSYS2 to detect packages properly
# Note: this hack necessitates a 64 bit build
if (MSYS)
  include_directories("/mingw64/include")
  link_directories("/mingw64/lib")
  set(PNG_ROOT "/mingw64")
  set(ZLIB_ROOT "/mingw64")
  set(Boost_ROOT "/mingw64")
endif ()

# Add the dynamic/shared library
set(APNGASM_DYNAMIC_LIB_TARGET apngasm)
add_library(${APNGASM_DYNAMIC_LIB_TARGET} SHARED
  ${APNGASM_SOURCES}
)
set_target_properties(${APNGASM_DYNAMIC_LIB_TARGET}
  PROPERTIES
  POSITION_INDEPENDENT_CODE TRUE
  OUTPUT_NAME apngasm
  CXX_STANDARD 20
)

# Add the static library/archive
set(APNGASM_STATIC_LIB_TARGET apngasm-static)
add_library(${APNGASM_STATIC_LIB_TARGET}
  ${APNGASM_SOURCES}
)
set_target_properties(${APNGASM_STATIC_LIB_TARGET}
  PROPERTIES
  POSITION_INDEPENDENT_CODE TRUE
  OUTPUT_NAME apngasm
  CXX_STANDARD 20
)

# Add libraries/includes
#target_link_libraries(${APNGASM_DYNAMIC_LIB_TARGET} stdc++fs)
#target_link_libraries(${APNGASM_STATIC_LIB_TARGET} stdc++fs)

find_package(ZLIB REQUIRED)
include_directories(${ZLIB_INCLUDE_DIRS})
target_link_libraries(${APNGASM_DYNAMIC_LIB_TARGET} ${ZLIB_LIBRARIES})
target_link_libraries(${APNGASM_STATIC_LIB_TARGET} ${ZLIB_LIBRARIES})

find_package(PNG REQUIRED)
include_directories(${PNG_INCLUDE_DIR})
target_link_libraries(${APNGASM_DYNAMIC_LIB_TARGET} ${PNG_LIBRARY})
target_link_libraries(${APNGASM_STATIC_LIB_TARGET} ${PNG_LIBRARY})
message(${PNG_VERSION_STRING})

#SET(CMAKE_FIND_LIBRARY_SUFFIXES .dll.a .a .lib ${CMAKE_FIND_LIBRARY_SUFFIXES})
find_package(Boost REQUIRED COMPONENTS program_options regex system)
include_directories(SYSTEM ${Boost_INCLUDE_DIRS})
target_link_libraries(${APNGASM_DYNAMIC_LIB_TARGET} Boost::program_options Boost::regex Boost::system)
target_link_libraries(${APNGASM_STATIC_LIB_TARGET} Boost::program_options Boost::regex Boost::system)

get_target_property(APNGASM_DYNAMIC_LIB_TARGET_NAME ${APNGASM_DYNAMIC_LIB_TARGET} OUTPUT_NAME)
get_target_property(APNGASM_STATIC_LIB_TARGET_NAME ${APNGASM_STATIC_LIB_TARGET} OUTPUT_NAME)
set(APNGASM_LIBRARIES
  ${PROJECT_BINARY_DIR}/${CMAKE_SHARED_LIBRARY_PREFIX}${APNGASM_DYNAMIC_LIB_TARGET_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX}
  ${PROJECT_BINARY_DIR}/${CMAKE_STATIC_LIBRARY_PREFIX}${APNGASM_STATIC_LIB_TARGET_NAME}${CMAKE_STATIC_LIBRARY_SUFFIX}
)

# Installation
install(FILES ${APNGASM_HEADERS}
  DESTINATION "include"
)
if (NOT DEFINED LIB_INSTALL_DIR)
  set(LIB_INSTALL_DIR "lib")
endif ()
install(
  TARGETS
    ${APNGASM_DYNAMIC_LIB_TARGET}
    ${APNGASM_STATIC_LIB_TARGET}
  DESTINATION ${LIB_INSTALL_DIR}
)

# Create package command
set(PACKAGE_DIR ${PROJECT_BINARY_DIR}/package)

if (WIN32)
  string(REPLACE "$(Configuration)" "\\\${CMAKE_INSTALL_CONFIG_NAME}" INSTALL_LIBS "${INSTALL_LIBS}")
endif ()

configure_file(${PROJECT_SOURCE_DIR}/package/CMakeLists.txt.in ${PACKAGE_DIR}/CMakeLists.txt @ONLY)

if (UNIX OR APPLE OR MINGW)
  add_custom_target(
    package-lib
    COMMAND ${CMAKE_COMMAND} .
    COMMAND ${CMAKE_MAKE_PROGRAM} package
    WORKING_DIRECTORY ${PACKAGE_DIR}
)
endif ()

# Package .in
if (NOT WIN32 OR CYGWIN OR MINGW)
  # Set some pkg-config variables
  set(prefix      ${CMAKE_INSTALL_PREFIX})
  set(exec_prefix ${CMAKE_INSTALL_PREFIX})
  set(libdir      ${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR})
  set(includedir  ${CMAKE_INSTALL_PREFIX}/include)
  set(LIBS "-lz -lpng")

  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libapngasm.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libapngasm.pc @ONLY)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libapngasm.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
endif ()

# SWIG
option(RUBY "Build Ruby interfaces")
option(JAVA "Build Java interfaces")

if (RUBY)
  include(${PROJECT_SOURCE_DIR}/interfaces/ruby/CMakeLists.txt)
endif ()

if (JAVA)
  include(${PROJECT_SOURCE_DIR}/interfaces/java/CMakeLists.txt)
endif ()

## apngasm python-1.0.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -109,7 +109,7 @@
     endif()
 endif()
 
-project(apngasm-python VERSION 1.0.3)
+project(apngasm-python VERSION 1.0.4)
 set(PY_VERSION_SUFFIX "")
 set(PY_FULL_VERSION ${PROJECT_VERSION}${PY_VERSION_SUFFIX})

## apngasm python-1.0.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -77,12 +77,13 @@
     set(ZLIB_ROOT ${VCPKG_INSTALLATION_ROOT}/installed)
     set(PNG_ROOT ${VCPKG_INSTALLATION_ROOT}/installed)
     set(Boost_ROOT ${VCPKG_INSTALLATION_ROOT}/installed)
-    
+
     set(VCPKG_TARGET_TRIPLET ${APNGASM_COMPILE_TARGET}-${PLATFORM})
 
     include_directories(${VCPKG_INSTALLATION_ROOT}/installed/${VCPKG_TARGET_TRIPLET}/include)
     set(LIBZ_PATH ${VCPKG_INSTALLATION_ROOT}/installed/${VCPKG_TARGET_TRIPLET}/lib/${LIBZ_NAME}${STATIC_LIBRARY_SUFFIX})
     set(LIBPNG_PATH ${VCPKG_INSTALLATION_ROOT}/installed/${VCPKG_TARGET_TRIPLET}/lib/${LIBPNG_NAME}${STATIC_LIBRARY_SUFFIX})
+    
     set(CMAKE_TOOLCHAIN_FILE "${VCPKG_INSTALLATION_ROOT}/scripts/buildsystems/vcpkg.cmake"
       CACHE STRING "Vcpkg toolchain file")
 else()
@@ -109,7 +110,7 @@
     endif()
 endif()
 
-project(apngasm-python VERSION 1.0.4)
+project(apngasm-python VERSION 1.0.5)
 set(PY_VERSION_SUFFIX "")
 set(PY_FULL_VERSION ${PROJECT_VERSION}${PY_VERSION_SUFFIX})

## apngasm python-1.0.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -110,7 +110,7 @@
     endif()
 endif()
 
-project(apngasm-python VERSION 1.0.5)
+project(apngasm-python VERSION 1.0.6)
 set(PY_VERSION_SUFFIX "")
 set(PY_FULL_VERSION ${PROJECT_VERSION}${PY_VERSION_SUFFIX})

## apngasm python-1.0.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17)
cmake_policy(SET CMP0074 NEW)

find_package(PythonInterp 3 REQUIRED)

set(GET_ARCH_CMD ${PYTHON_EXECUTABLE} "${CMAKE_SOURCE_DIR}/get_arch.py")
set(GET_DEPS_CMD ${PYTHON_EXECUTABLE} "${CMAKE_SOURCE_DIR}/get_deps.py")

message(STATUS "Executing get_arch.py")
execute_process(
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    COMMAND ${GET_ARCH_CMD}
    OUTPUT_VARIABLE APNGASM_COMPILE_TARGET
)
message(STATUS "Finished get_arch.py")
message(STATUS "APNGASM_COMPILE_TARGET is ${APNGASM_COMPILE_TARGET}")

message(STATUS "Executing get_deps.py")
execute_process(
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    COMMAND ${GET_DEPS_CMD}
)
message(STATUS "Finished get_deps.py")

if (WIN32)
    set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
elseif (LINUX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
elseif (APPLE)
    if(${APNGASM_COMPILE_TARGET} STREQUAL "x86_64")
        set(CMAKE_OSX_DEPLOYMENT_TARGET "11.0")
    else()
        set(CMAKE_OSX_DEPLOYMENT_TARGET "10.15")
    endif()
endif()

set(ZLIB_USE_STATIC_LIBS ON)
set(PNG_USE_STATIC_LIBS ON)
set(Boost_USE_STATIC_LIBS ON)
if (WIN32)
    set(Boost_USE_MULTITHREADED ON)
    set(Boost_USE_STATIC_RUNTIME ON)
endif()

# Add conan packages
if ("${APNGASM_COMPILE_TARGET}" STREQUAL "universal2")
    # x86_64 Contians static libraries that are universal2
    set(CONAN_TOOLCHAIN ${CMAKE_SOURCE_DIR}/conan_output/x86_64/conan_toolchain.cmake)
else()
    set(CONAN_TOOLCHAIN ${CMAKE_SOURCE_DIR}/conan_output/${APNGASM_COMPILE_TARGET}/conan_toolchain.cmake)
endif()

if (EXISTS ${CONAN_TOOLCHAIN})
    include(${CONAN_TOOLCHAIN})
else()
    message(WARNING "The conan_toolchain file could not be found: ${CONAN_TOOLCHAIN}")
endif()

project(apngasm-python VERSION 1.0.7)
set(PY_VERSION_SUFFIX "")
set(PY_FULL_VERSION ${PROJECT_VERSION}${PY_VERSION_SUFFIX})

# Make sure that the Python and CMake versions match
if (DEFINED PY_BUILD_CMAKE_PACKAGE_VERSION)
    if (NOT "${PY_BUILD_CMAKE_PACKAGE_VERSION}" MATCHES "^${PY_FULL_VERSION}$")
        message(FATAL_ERROR "Version number does not match "
                             "(${PY_BUILD_CMAKE_PACKAGE_VERSION} - ${PY_FULL_VERSION}).")
    endif()
endif()

# Find the nanobind package
include(cmake/QueryPythonForNanobind.cmake)
find_nanobind_python_first()

# Compile the Python module
nanobind_add_module(_apngasm_python "src/apngasm_python.cpp" NB_STATIC STABLE_ABI)
if (WIN32)
    nanobind_compile_options(_apngasm_python "/MT /MP /bigobj")
endif()
target_compile_definitions(_apngasm_python PRIVATE _apngasm_python_EXPORTS)
target_compile_definitions(_apngasm_python PRIVATE apngasm_EXPORTS)

# Static linking
add_subdirectory(apngasm)
set_target_properties(apngasm-static PROPERTIES BUILD_SHARED_LIBS OFF)

include_directories(${CMAKE_BINARY_DIR}/apngasm/lib/src)
include_directories(${CMAKE_SOURCE_DIR}/apngasm/lib/src)
include_directories(${CMAKE_SOURCE_DIR}/apngasm/lib/src/listener)

target_link_libraries(_apngasm_python PRIVATE apngasm-static)
target_compile_definitions(_apngasm_python PRIVATE
    MODULE_NAME=$<TARGET_FILE_BASE_NAME:_apngasm_python>
    VERSION_INFO="${PY_FULL_VERSION}"
)

# Hide all symbols by default (including external libraries on Linux)
set_target_properties(_apngasm_python PROPERTIES
    CXX_VISIBILITY_PRESET "hidden"
    VISIBILITY_INLINES_HIDDEN true
    POSITION_INDEPENDENT_CODE true)
if (WIN32)
    set_target_properties(_apngasm_python PROPERTIES LINK_FALGS_RELEASE "/WHOLEARCHIVE:MNN")
elseif (LINUX)
    target_link_options(_apngasm_python PRIVATE "LINKER:--exclude-libs,ALL")
endif()

# Install the module
install(TARGETS _apngasm_python
    EXCLUDE_FROM_ALL
    DESTINATION ${PY_BUILD_CMAKE_MODULE_NAME}
    COMPONENT python_module)

# Generate stubs for the Python module
option(WITH_PY_STUBS
    "Generate Python stub files (.pyi) for the Python module." On)
if (WITH_PY_STUBS AND NOT CMAKE_CROSSCOMPILING)
    include(cmake/NanobindStubgen.cmake)
    nanobind_stubgen(_apngasm_python)
    nanobind_stubgen_install(_apngasm_python ${PY_BUILD_CMAKE_MODULE_NAME})
endif()

## apngasm python-1.0.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -55,10 +55,10 @@
 if (EXISTS ${CONAN_TOOLCHAIN})
     include(${CONAN_TOOLCHAIN})
 else()
-    message(WARNING "The conan_toolchain file could not be found: ${CONAN_TOOLCHAIN}")
+    message(FATAL_ERROR "The conan_toolchain file could not be found: ${CONAN_TOOLCHAIN}")
 endif()
 
-project(apngasm-python VERSION 1.0.7)
+project(apngasm-python VERSION 1.0.8)
 set(PY_VERSION_SUFFIX "")
 set(PY_FULL_VERSION ${PROJECT_VERSION}${PY_VERSION_SUFFIX})

## apngasm python-1.0.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -58,7 +58,7 @@
     message(FATAL_ERROR "The conan_toolchain file could not be found: ${CONAN_TOOLCHAIN}")
 endif()
 
-project(apngasm-python VERSION 1.0.8)
+project(apngasm-python VERSION 1.0.9)
 set(PY_VERSION_SUFFIX "")
 set(PY_FULL_VERSION ${PROJECT_VERSION}${PY_VERSION_SUFFIX})

=== apngasm/cli/CMakeLists.txt ===
--- 
+++ 
@@ -34,9 +34,6 @@
 find_package(Boost REQUIRED COMPONENTS program_options regex system)
 include_directories(${Boost_INCLUDE_DIRS})
 
-find_package(ZLIB REQUIRED)
-include_directories(${ZLIB_INCLUDE_DIRS})
-
 find_package(PNG REQUIRED)
 include_directories(${PNG_INCLUDE_DIRS})
 
@@ -55,7 +52,7 @@
 # Link to built apngasm library
 target_link_libraries(apngasm-cli
   apngasm
-  ${Boost_LIBRARIES} ${PNG_LIBRARIES} ${ZLIB_LIBRARIES}
+  ${Boost_LIBRARIES}
 )
 
 # Installation

=== apngasm/lib/CMakeLists.txt ===
--- 
+++ 
@@ -78,15 +78,15 @@
 
 find_package(PNG REQUIRED)
 include_directories(${PNG_INCLUDE_DIR})
-target_link_libraries(${APNGASM_DYNAMIC_LIB_TARGET} ${PNG_LIBRARY})
-target_link_libraries(${APNGASM_STATIC_LIB_TARGET} ${PNG_LIBRARY})
+target_link_libraries(${APNGASM_DYNAMIC_LIB_TARGET} ${PNG_LIBRARIES})
+target_link_libraries(${APNGASM_STATIC_LIB_TARGET} ${PNG_LIBRARIES})
 message(${PNG_VERSION_STRING})
 
 #SET(CMAKE_FIND_LIBRARY_SUFFIXES .dll.a .a .lib ${CMAKE_FIND_LIBRARY_SUFFIXES})
 find_package(Boost REQUIRED COMPONENTS program_options regex system)
 include_directories(SYSTEM ${Boost_INCLUDE_DIRS})
-target_link_libraries(${APNGASM_DYNAMIC_LIB_TARGET} Boost::program_options Boost::regex Boost::system)
-target_link_libraries(${APNGASM_STATIC_LIB_TARGET} Boost::program_options Boost::regex Boost::system)
+target_link_libraries(${APNGASM_DYNAMIC_LIB_TARGET} ${Boost_LIBRARIES})
+target_link_libraries(${APNGASM_STATIC_LIB_TARGET} ${Boost_LIBRARIES})
 
 get_target_property(APNGASM_DYNAMIC_LIB_TARGET_NAME ${APNGASM_DYNAMIC_LIB_TARGET} OUTPUT_NAME)
 get_target_property(APNGASM_STATIC_LIB_TARGET_NAME ${APNGASM_STATIC_LIB_TARGET} OUTPUT_NAME)

## apngasm python-1.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -58,7 +58,7 @@
     message(FATAL_ERROR "The conan_toolchain file could not be found: ${CONAN_TOOLCHAIN}")
 endif()
 
-project(apngasm-python VERSION 1.0.9)
+project(apngasm-python VERSION 1.1.0)
 set(PY_VERSION_SUFFIX "")
 set(PY_FULL_VERSION ${PROJECT_VERSION}${PY_VERSION_SUFFIX})
 
@@ -109,9 +109,9 @@
 
 # Install the module
 install(TARGETS _apngasm_python
-    EXCLUDE_FROM_ALL
-    DESTINATION ${PY_BUILD_CMAKE_MODULE_NAME}
-    COMPONENT python_module)
+        EXCLUDE_FROM_ALL
+        DESTINATION ${PY_BUILD_CMAKE_MODULE_NAME}
+        COMPONENT python_modules)
 
 # Generate stubs for the Python module
 option(WITH_PY_STUBS

## apngasm python-1.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,8 +3,8 @@
 
 find_package(PythonInterp 3 REQUIRED)
 
-set(GET_ARCH_CMD ${PYTHON_EXECUTABLE} "${CMAKE_SOURCE_DIR}/get_arch.py")
-set(GET_DEPS_CMD ${PYTHON_EXECUTABLE} "${CMAKE_SOURCE_DIR}/get_deps.py")
+set(GET_ARCH_CMD ${PYTHON_EXECUTABLE} "${CMAKE_SOURCE_DIR}/scripts/get_arch.py")
+set(GET_DEPS_CMD ${PYTHON_EXECUTABLE} "${CMAKE_SOURCE_DIR}/scripts/get_deps.py")
 
 message(STATUS "Executing get_arch.py")
 execute_process(
@@ -58,7 +58,7 @@
     message(FATAL_ERROR "The conan_toolchain file could not be found: ${CONAN_TOOLCHAIN}")
 endif()
 
-project(apngasm-python VERSION 1.1.0)
+project(apngasm-python VERSION 1.2.0)
 set(PY_VERSION_SUFFIX "")
 set(PY_FULL_VERSION ${PROJECT_VERSION}${PY_VERSION_SUFFIX})
 
@@ -119,5 +119,9 @@
 if (WITH_PY_STUBS AND NOT CMAKE_CROSSCOMPILING)
     include(cmake/NanobindStubgen.cmake)
     nanobind_stubgen(_apngasm_python)
+    add_custom_command(TARGET _apngasm_python POST_BUILD
+        COMMAND ${PYTHON_EXECUTABLE} patch_stub.py $<TARGET_FILE_DIR:_apngasm_python>/_apngasm_python.pyi
+        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/scripts
+        USES_TERMINAL)
     nanobind_stubgen_install(_apngasm_python ${PY_BUILD_CMAKE_MODULE_NAME})
 endif()

## apngasm python-1.2.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -58,7 +58,7 @@
     message(FATAL_ERROR "The conan_toolchain file could not be found: ${CONAN_TOOLCHAIN}")
 endif()
 
-project(apngasm-python VERSION 1.2.0)
+project(apngasm-python VERSION 1.2.2)
 set(PY_VERSION_SUFFIX "")
 set(PY_FULL_VERSION ${PROJECT_VERSION}${PY_VERSION_SUFFIX})

## apngasm python-1.2.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -58,7 +58,7 @@
     message(FATAL_ERROR "The conan_toolchain file could not be found: ${CONAN_TOOLCHAIN}")
 endif()
 
-project(apngasm-python VERSION 1.2.2)
+project(apngasm-python VERSION 1.2.3)
 set(PY_VERSION_SUFFIX "")
 set(PY_FULL_VERSION ${PROJECT_VERSION}${PY_VERSION_SUFFIX})

## apngasm python-1.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,32 +22,35 @@
 )
 message(STATUS "Finished get_deps.py")
 
-if (WIN32)
+if (MSVC)
     set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
     set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
     set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
+    set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /Zi /Ob0 /Od /RTC1")
 elseif (LINUX)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
 elseif (APPLE)
-    if(${APNGASM_COMPILE_TARGET} STREQUAL "x86_64")
+    if(${APNGASM_COMPILE_TARGET} STREQUAL "armv8")
         set(CMAKE_OSX_DEPLOYMENT_TARGET "11.0")
     else()
-        set(CMAKE_OSX_DEPLOYMENT_TARGET "10.15")
+        set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9")
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x -stdlib=libc++ -fno-aligned-allocation")
     endif()
 endif()
 
 set(ZLIB_USE_STATIC_LIBS ON)
 set(PNG_USE_STATIC_LIBS ON)
 set(Boost_USE_STATIC_LIBS ON)
-if (WIN32)
+if (MSVC)
     set(Boost_USE_MULTITHREADED ON)
     set(Boost_USE_STATIC_RUNTIME ON)
 endif()
 
 # Add conan packages
-if ("${APNGASM_COMPILE_TARGET}" STREQUAL "universal2")
-    # x86_64 Contians static libraries that are universal2
+if ("${APNGASM_COMPILE_TARGET}" STREQUAL "universal2_x86_64")
     set(CONAN_TOOLCHAIN ${CMAKE_SOURCE_DIR}/conan_output/x86_64/conan_toolchain.cmake)
+elseif ("${APNGASM_COMPILE_TARGET}" STREQUAL "universal2_armv8")
+    set(CONAN_TOOLCHAIN ${CMAKE_SOURCE_DIR}/conan_output/armv8/conan_toolchain.cmake)
 else()
     set(CONAN_TOOLCHAIN ${CMAKE_SOURCE_DIR}/conan_output/${APNGASM_COMPILE_TARGET}/conan_toolchain.cmake)
 endif()
@@ -58,7 +61,7 @@
     message(FATAL_ERROR "The conan_toolchain file could not be found: ${CONAN_TOOLCHAIN}")
 endif()
 
-project(apngasm-python VERSION 1.2.3)
+project(apngasm-python VERSION 1.3.0)
 set(PY_VERSION_SUFFIX "")
 set(PY_FULL_VERSION ${PROJECT_VERSION}${PY_VERSION_SUFFIX})
 
@@ -76,7 +79,7 @@
 
 # Compile the Python module
 nanobind_add_module(_apngasm_python "src/apngasm_python.cpp" NB_STATIC STABLE_ABI)
-if (WIN32)
+if (MSVC)
     nanobind_compile_options(_apngasm_python "/MT /MP /bigobj")
 endif()
 target_compile_definitions(_apngasm_python PRIVATE _apngasm_python_EXPORTS)
@@ -101,7 +104,7 @@
     CXX_VISIBILITY_PRESET "hidden"
     VISIBILITY_INLINES_HIDDEN true
     POSITION_INDEPENDENT_CODE true)
-if (WIN32)
+if (MSVC)
     set_target_properties(_apngasm_python PROPERTIES LINK_FALGS_RELEASE "/WHOLEARCHIVE:MNN")
 elseif (LINUX)
     target_link_options(_apngasm_python PRIVATE "LINKER:--exclude-libs,ALL")
@@ -114,14 +117,13 @@
         COMPONENT python_modules)
 
 # Generate stubs for the Python module
-option(WITH_PY_STUBS
-    "Generate Python stub files (.pyi) for the Python module." On)
-if (WITH_PY_STUBS AND NOT CMAKE_CROSSCOMPILING)
-    include(cmake/NanobindStubgen.cmake)
-    nanobind_stubgen(_apngasm_python)
-    add_custom_command(TARGET _apngasm_python POST_BUILD
-        COMMAND ${PYTHON_EXECUTABLE} patch_stub.py $<TARGET_FILE_DIR:_apngasm_python>/_apngasm_python.pyi
-        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/scripts
-        USES_TERMINAL)
-    nanobind_stubgen_install(_apngasm_python ${PY_BUILD_CMAKE_MODULE_NAME})
-endif()
+nanobind_add_stub(
+    apngasm_python_stub
+    INSTALL_TIME
+    MODULE apngasm_python._apngasm_python
+    OUTPUT "${PY_BUILD_CMAKE_MODULE_NAME}/_apngasm_python.pyi"
+    MARKER_FILE "${PY_BUILD_CMAKE_MODULE_NAME}/py.typed"
+    COMPONENT python_modules
+    EXCLUDE_FROM_ALL
+    VERBOSE
+)

=== apngasm/test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

project(APNGASM_TEST)

link_directories(BEFORE ${PROJECT_BINARY_DIR}/../lib)

enable_testing()

# Generate C++ test
add_executable(apngasm-cpp-test
  EXCLUDE_FROM_ALL
  ${PROJECT_SOURCE_DIR}/cpp/apngasm-test.cpp
)

set_target_properties(apngasm-cpp-test
  PROPERTIES
  OUTPUT_NAME apngasm-cpp-test
)

link_directories(${PROJECT_BINARY_DIR}/lib)
include_directories(
  ${PROJECT_SOURCE_DIR}/../lib/src
  ${CMAKE_BINARY_DIR}/lib/src
)
target_link_libraries(apngasm-cpp-test apngasm)

add_test(NAME apngasm-cpp-test
  COMMAND apngasm-cpp-test ${PROJECT_SOURCE_DIR}/samples
)

find_package(PNG REQUIRED)
include_directories(${PNG_INCLUDE_DIRS})
target_link_libraries(apngasm-cpp-test ${PNG_LIBRARIES})
find_package(ZLIB REQUIRED)
include_directories(${ZLIB_INCLUDE_DIRS})
target_link_libraries(apngasm-cpp-test ${ZLIB_LIBRARIES})

#file(COPY ${PROJECT_SOURCE_DIR}/samples DESTINATION ./)
file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/cli-out)
file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/cpp-out)

add_custom_command(
  DEPENDS
    ${CMAKE_BINARY_DIR}/test/apngasm-cpp-test
  OUTPUT
    ${CMAKE_BINARY_DIR}/test/cpp-out/circle_anim.png
    ${CMAKE_BINARY_DIR}/test/cpp-out/circle_anim2.png
    ${CMAKE_BINARY_DIR}/test/cpp-out/penguins.json
    ${CMAKE_BINARY_DIR}/test/cpp-out/penguins.xml
    ${CMAKE_BINARY_DIR}/test/cpp-out/test5_anim.png

  COMMAND apngasm-cpp-test ${PROJECT_SOURCE_DIR}/samples
)

add_custom_command(
  OUTPUT
    ${CMAKE_BINARY_DIR}/test/cli-out/logo-test.png

  COMMAND ${PROJECT_SOURCE_DIR}/cli/logo-test.sh
)

add_custom_command(
  OUTPUT
    ${CMAKE_BINARY_DIR}/test/cli-out/delay-test.png

  COMMAND ${PROJECT_SOURCE_DIR}/cli/delay-test.sh
)

add_custom_command(
  OUTPUT
    ${CMAKE_BINARY_DIR}/test/cli-out/json-test.png

  COMMAND ${PROJECT_SOURCE_DIR}/cli/json-test.sh
)

add_custom_command(
  OUTPUT
    ${CMAKE_BINARY_DIR}/test/cli-out/xml-test.png

  COMMAND ${PROJECT_SOURCE_DIR}/cli/xml-test.sh
)

add_custom_command(
  OUTPUT
   	${CMAKE_BINARY_DIR}/test/cli-out/disassemble-test/33.png
   	${CMAKE_BINARY_DIR}/test/cli-out/disassemble-test/animation.json
   	${CMAKE_BINARY_DIR}/test/cli-out/disassemble-test/xanimation.xml

  COMMAND ${PROJECT_SOURCE_DIR}/cli/disassemble-test.sh
)

add_custom_target(test
  DEPENDS
	# CPP
    ${CMAKE_BINARY_DIR}/test/cpp-out/circle_anim.png
    ${CMAKE_BINARY_DIR}/test/cpp-out/circle_anim2.png
    ${CMAKE_BINARY_DIR}/test/cpp-out/penguins.json
    ${CMAKE_BINARY_DIR}/test/cpp-out/penguins.xml
    ${CMAKE_BINARY_DIR}/test/cpp-out/test5_anim.png

	# CLI
    ${CMAKE_BINARY_DIR}/test/cli-out/logo-test.png
	${CMAKE_BINARY_DIR}/test/cli-out/delay-test.png
   	${CMAKE_BINARY_DIR}/test/cli-out/json-test.png
   	${CMAKE_BINARY_DIR}/test/cli-out/xml-test.png
   	${CMAKE_BINARY_DIR}/test/cli-out/disassemble-test/33.png
   	${CMAKE_BINARY_DIR}/test/cli-out/disassemble-test/animation.json
   	${CMAKE_BINARY_DIR}/test/cli-out/disassemble-test/xanimation.xml
)

## apngasm python-1.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -61,7 +61,7 @@
     message(FATAL_ERROR "The conan_toolchain file could not be found: ${CONAN_TOOLCHAIN}")
 endif()
 
-project(apngasm-python VERSION 1.3.0)
+project(apngasm-python VERSION 1.3.1)
 set(PY_VERSION_SUFFIX "")
 set(PY_FULL_VERSION ${PROJECT_VERSION}${PY_VERSION_SUFFIX})

=== apngasm/lib/CMakeLists.txt ===
--- 
+++ 
@@ -52,7 +52,6 @@
   PROPERTIES
   POSITION_INDEPENDENT_CODE TRUE
   OUTPUT_NAME apngasm
-  CXX_STANDARD 20
 )
 
 # Add the static library/archive
@@ -64,7 +63,6 @@
   PROPERTIES
   POSITION_INDEPENDENT_CODE TRUE
   OUTPUT_NAME apngasm
-  CXX_STANDARD 20
 )
 
 # Add libraries/includes
@@ -83,7 +81,7 @@
 message(${PNG_VERSION_STRING})
 
 #SET(CMAKE_FIND_LIBRARY_SUFFIXES .dll.a .a .lib ${CMAKE_FIND_LIBRARY_SUFFIXES})
-find_package(Boost REQUIRED COMPONENTS program_options regex system)
+find_package(Boost REQUIRED COMPONENTS program_options regex system filesystem)
 include_directories(SYSTEM ${Boost_INCLUDE_DIRS})
 target_link_libraries(${APNGASM_DYNAMIC_LIB_TARGET} ${Boost_LIBRARIES})
 target_link_libraries(${APNGASM_STATIC_LIB_TARGET} ${Boost_LIBRARIES})

## apngasm python-1.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -61,7 +61,7 @@
     message(FATAL_ERROR "The conan_toolchain file could not be found: ${CONAN_TOOLCHAIN}")
 endif()
 
-project(apngasm-python VERSION 1.3.1)
+project(apngasm-python VERSION 1.3.2)
 set(PY_VERSION_SUFFIX "")
 set(PY_FULL_VERSION ${PROJECT_VERSION}${PY_VERSION_SUFFIX})

=== apngasm/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,5 @@
 cmake_minimum_required(VERSION 3.13)
+cmake_policy(SET CMP0074 NEW)
 
 project(APNGASM)

=== apngasm/cli/CMakeLists.txt ===
--- 
+++ 
@@ -31,7 +31,7 @@
 endif ()
 
 # Search and prepare Boost
-find_package(Boost REQUIRED COMPONENTS program_options regex system)
+find_package(Boost REQUIRED COMPONENTS program_options regex filesystem system)
 include_directories(${Boost_INCLUDE_DIRS})
 
 find_package(PNG REQUIRED)
@@ -46,7 +46,6 @@
 set_target_properties(apngasm-cli
   PROPERTIES 
   OUTPUT_NAME apngasm
-  CXX_STANDARD 20
 )
 
 # Link to built apngasm library
